<?php
/**
 * 
 * @category  Payment Integration
 * @package   Risecommerce_Elavon* 
 * @copyright 2024 Rise Core Technologies Pvt. Ltd.. (https://risecommerce.com/)
 */
namespace Risecommerce\Elavon\Block\Adminhtml\System\Config;

use Magento\Config\Block\System\Config\Form\Field;
use Magento\Framework\Data\Form\Element\AbstractElement;

class CallBackUrls extends Field
{
    protected function _getElementHtml(AbstractElement $element)
    {
        $element->setDisabled('disabled');
        return $element->getElementHtml();
    }

    protected function _renderValue(AbstractElement $element)
    {
        $field_config = $element->getData('field_config');
        $id = $field_config['id'];
        
        $approvedUrl = $this->_urlBuilder->getBaseUrl().'rc_elavon/hosted/approved';
        $cancelUrl = $this->_urlBuilder->getBaseUrl().'rc_elavon/hosted/cancel';
        
        switch ($id) {
            case 'approved_url':
                $element->addData([
                    'value' => $approvedUrl
                ]);
                break;
            case 'cancel_url':
                $element->addData([
                    'value' => $cancelUrl
                ]);
                break;
            default:
                $element->addData([
                    'value' => $approvedUrl
                ]);
                break;
        }
        return parent::_renderValue($element);
    }
}