<?php
/**
 * Elavon Payment Module.
 *
 * @category  Payment Integration
 * @package   Risecommerce_Elavon
 * @copyright 2024 Rise Core Technologies Pvt. Ltd.. (https://risecommerce.com/)
 */

namespace Risecommerce\Elavon\Block;

class GCaptcha extends \Magento\Framework\View\Element\Template
{
    /**
     * @var \Risecommerce\Elavon\Helper\Data
     */
    protected $helper;

    /**
     * @param \Magento\Framework\View\Element\Template\Context $context
     * @param \Risecommerce\Elavon\Helper\Data $helper
     * @param array $data
     */
    public function __construct(
        \Magento\Framework\View\Element\Template\Context $context,
        \Risecommerce\Elavon\Helper\Data $helper,
        array $data = []
    ) {
        $this->helper = $helper;
        parent::__construct($context, $data);
    }

    protected function _construct()
    {
        if ($this->helper->getEnableCaptcha() == 1 &&
            $this->helper->getConfig('payment/risecommerce_elavon_option/captcha_js')
           ) {
            $this->pageConfig->addRemotePageAsset(
                'https://www.google.com/recaptcha/api.js',
                'js',
                ['attributes' => 'async defer']
            );
        }

        if ($this->helper->getEnableCaptcha() == 3) {
            $this->pageConfig->addRemotePageAsset(
                'https://www.google.com/recaptcha/api.js?render='.$this->helper->getCaptchaSiteKey(),
                'js',
                ['attributes' => 'async defer']
            );
        }
    }
}
