<?php
/**
 * Elavon Hosted Payment Module.
 *
 * @category  Payment Integration
 * @package   Risecommerce_Elavon
 * @copyright 2024 Rise Core Technologies Pvt. Ltd.. (https://risecommerce.com/)
 */
namespace Risecommerce\Elavon\Controller\Hosted;

use Magento\Framework\Controller\ResultFactory;

/**
 * Class Cancel
 */
class Cancel extends AbstractExpress
{
    /** @var string */
    protected $_configMethod = \Risecommerce\Elavon\Model\PaymentHosted::CODE_HOSTED;

    /** @var string */
    protected $_checkoutType = \Risecommerce\Elavon\Model\HostedPage\Checkout::class;

    public function execute()
    {
        $errorMsg = __('Something went wrong. Your last transaction has been canceled.');
        $this->messageManager->addError(
            $errorMsg
        );

        $resultRedirect = $this->resultFactory->create(ResultFactory::TYPE_REDIRECT);
        return $resultRedirect->setPath('checkout/cart');
    }
}
