<?php
/**
 * Elavon Payment Module.
 *
 * @category  Payment Integration
 * @package   Risecommerce_Elavon
 * @copyright 2024 Rise Core Technologies Pvt. Ltd.. (https://risecommerce.com/)
 */
namespace Risecommerce\Elavon\Controller\Hosted;

use Risecommerce\Elavon\Controller\Hosted\GetToken;

class Start extends GetToken
{
    /** @var string */
    protected $_checkoutType = \Risecommerce\Elavon\Model\HostedPage\Checkout::class;

    public function execute()
    {
        try {
            $token = $this->getToken();
            if ($token === null) {
                return;
            }
            $hostedFinalUrl = $this->customHelper->getFormAction() . '?ssl_txn_auth_token='.$token;
            $resultRedirect = $this->resultRedirectFactory->create();
            $resultRedirect->setUrl($hostedFinalUrl);
            return $resultRedirect;

        } catch (\Magento\Framework\Exception\LocalizedException $e) {
            $this->messageManager->addExceptionMessage($e, $e->getMessage());
        } catch (\Exception $e) {
            $this->messageManager->addExceptionMessage(
                $e,
                __('We can\'t start hosted payment page.')
            );
        }

        $this->_redirect('checkout/cart');
    }
}
