<?php
/**
 * Elavon Payment Model.
 *
 * @category  Payment Integration
 * @package   Risecommerce_Elavon
 * @copyright 2024 Rise Core Technologies Pvt. Ltd.. (https://risecommerce.com/)
 */
namespace Risecommerce\Elavon\Gateway\Http;

/**
 * Class TransferFactory
 */
class TransferFactory extends AbstractTransferFactory
{
    public function create(array $request)
    {
        $this->rcLogger($request);
        $xml = $this->convertToXml($request);
        $xml = !empty($xml) ? trim(str_replace('<?xml version="1.0"?>', '', $xml)) : $xml;
        $replaceFrom = ["%", "=", "&"];
        $replaceTo = ["percentage", "equal", "and"];
        $xmlNew = str_replace($replaceFrom, $replaceTo, $xml);
        $postData = "xmldata=" . URLEncode($xmlNew);
        $header[] = "Content-Type: application/x-www-form-urlencoded";
        $header[] = "Content-length: ".strlen($postData);
        return $this->transferBuilder
            ->setMethod('POST')
            ->setHeaders($header)
            ->setBody($postData)
            ->setUri($this->getUrl())
            ->build();
    }
}
