<?php
/**
 * Elavon Payment Model.
 *
 * @category  Payment Integration
 * @package   Risecommerce_Elavon
 * @copyright 2024 Rise Core Technologies Pvt. Ltd.. (https://risecommerce.com/)
 */
namespace Risecommerce\Elavon\Gateway\Request;

/**
 * Class CommonDataBuilder
 */
class CommonDataBuilder extends GeneralDataBuilder
{
    public function build(array $buildSubject)
    {
        $paymentDO = $this->subjectReader->readPayment($buildSubject);
        $order = $paymentDO->getOrder();

        $result = [
            "ssl_merchant_id" =>  $this->customHelper->getMerchantId($order->getStoreId()),
            "ssl_pin" => $this->customHelper->getElavonPin($order->getStoreId()),
            "ssl_user_id" => $this->customHelper->getUserId($order->getStoreId())
        ];

        return $result;
    }
}
