<?php
/**
 * Elavon Payment Model.
 *
 * @category  Payment Integration
 * @package   Risecommerce_Elavon
 * @copyright 2024 Rise Core Technologies Pvt. Ltd.. (https://risecommerce.com/)
 */
namespace Risecommerce\Elavon\Gateway\Request;

use Magento\Payment\Gateway\Helper\SubjectReader;

/**
 * Class OrderDataBuilder
 */
class OrderDataBuilder extends GeneralDataBuilder
{
    public function build(array $buildSubject)
    {
        $paymentDO = SubjectReader::readPayment($buildSubject);
        $payment = $paymentDO->getPayment();
        $order = $payment->getOrder();

        $ssl_amount = number_format(SubjectReader::readAmount($buildSubject), 2,'.', '');
        $ssl_salestax = !empty($order->getBaseTaxAmount()) ? number_format($order->getBaseTaxAmount(), 2, '.', '') : 0.00;
        if ($this->customHelper->getPayInStoreCurrency()) {
            $ssl_amount = number_format($order->getGrandTotal(), 2, '.', '');
            $ssl_salestax = !empty($order->getTaxAmount()) ? number_format($order->getTaxAmount(), 2, '.', '') : 0.00;
        }
        $customerId = !empty($order ->getCustomerId()) ? $order ->getCustomerId() : '';
        $ssl_description = sprintf('Order # %s', $order->getIncrementId());

        $result = [
            'ssl_amount' => $ssl_amount,
            'ssl_customer_code' => $customerId,
            'ssl_salestax' => $ssl_salestax,
            'ssl_invoice_number' => $paymentDO->getOrder()->getOrderIncrementId(),
            'ssl_cardholder_ip' => $this->customHelper->getClientIp(),
            'ssl_description' => $ssl_description,
            'products' => $ssl_amount . "::1::001::" . $ssl_description . "::"
        ];

        return $result;
    }
}
