<?php
namespace Risecommerce\Elavon\Gateway\Request;

use Magento\Payment\Gateway\Helper\SubjectReader;

/**
 * Class RefundDataBuilder
 */
class RefundDataBuilder extends GeneralDataBuilder
{
    public function build(array $buildSubject)
    {
        $paymentDO = SubjectReader::readPayment($buildSubject);
        $payment = $paymentDO->getPayment();
        $order = $payment->getOrder();
        $chargeId = str_replace('-refund', '', $payment->getTransactionId());
        $ssl_description = sprintf('Order # %s', $order->getIncrementId());
        $ssl_amount = number_format(SubjectReader::readAmount($buildSubject), 2, '.', '');

        $grandTotal = $order->getBaseGrandTotal();
        if ($this->customHelper->getPayInStoreCurrency()) {
            $rate = $this->currencyFactory->create()
                ->load($order->getBaseCurrencyCode())
                ->getAnyRate($order->getOrderCurrencyCode());

            $convertedPrice = $ssl_amount * $rate;
            $ssl_amount = number_format($convertedPrice, 2, '.', '');
            $grandTotal = $order->getGrandTotal();
        }

        $result = [
            "ssl_transaction_type" => 'ccreturn',
            "ssl_description" => $ssl_description,
            "ssl_txn_id" => $chargeId,
            "ssl_amount" => $ssl_amount
        ];

        if ((float)$ssl_amount < (float)$grandTotal) {
            $result['ssl_partial_shipment_flag'] = 'Y';
        }

        return $result;
    }
}
