<?php
/**
 * Elavon Payment Model.
 *
 * @category  Payment Integration
 * @package   Risecommerce_Elavon
 * @copyright 2024 Rise Core Technologies Pvt. Ltd.. (https://risecommerce.com/)
 */
namespace Risecommerce\Elavon\Gateway\Request\Vault;

use Magento\Payment\Model\MethodInterface;
use Risecommerce\Elavon\Gateway\Request\GeneralDataBuilder;

/**
 * Class TransactionDataBuilder
 */
class TransactionDataBuilder extends GeneralDataBuilder
{
    public function build(array $buildSubject)
    {
        $paymentDO = $this->subjectReader->readPayment($buildSubject);
        $payment = $paymentDO->getPayment();

        $extensionAttributes = $payment->getExtensionAttributes();
        $paymentToken = $extensionAttributes->getVaultPaymentToken();
        $ssl_transaction_type = $this->customHelper->getConfig('payment/risecommerce_elavon_option/payment_action') == MethodInterface::ACTION_AUTHORIZE ? "ccauthonly" : "ccsale";

        $result = [
            'ssl_transaction_type' => $ssl_transaction_type,
            "ssl_token" => $paymentToken->getGatewayToken()
        ];

        return $result;
    }
}
