<?php
namespace Risecommerce\Elavon\Gateway\Response;

use Magento\Payment\Gateway\Helper\SubjectReader;
use Magento\Payment\Gateway\Response\HandlerInterface;

/**
 * Class AVSHandler
 */
class AVSHandler implements HandlerInterface
{
    /**
     * @inheritdoc
     */
    public function handle(array $handlingSubject, array $response)
    {
        $paymentDO = SubjectReader::readPayment($handlingSubject);
        $payment = $paymentDO->getPayment();

        if (!empty($response['ssl_avs_response'])) {
            $payment->setCcAvsStatus($response['ssl_avs_response']);
            $payment->setAdditionalInformation("avs_result", $response['ssl_avs_response']);
        }
        if (!empty($response['ssl_cvv2_response'])) {
            $payment->setCcCidStatus($response['ssl_cvv2_response']);
            $payment->setAdditionalInformation("cvd_result", $response['ssl_cvv2_response']);
        }
    }
}
