<?php
/**
 * Elavon Payment Model.
 *
 * @category  Payment Integration
 * @package   Risecommerce_Elavon
 * @copyright 2024 Rise Core Technologies Pvt. Ltd.. (https://risecommerce.com/)
 */
namespace Risecommerce\Elavon\Model;

use Magento\Checkout\Model\ConfigProviderInterface;

/**
 * Class ConfigProviderHosted
 */
class ConfigProviderHosted implements ConfigProviderInterface
{
    const CODE = 'risecommerce_elavonhosted_option';
    protected $methodCodes = [
        self::CODE
    ];

    /**
     * @var \Risecommerce\Elavon\Helper\Data
     */
    protected $dataHelper;


    /**
     * @param \Risecommerce\Elavon\Helper\Data $customHelper
     */
    public function __construct(
        \Risecommerce\Elavon\Helper\Data $customHelper
    ) {
        $this->dataHelper = $customHelper;
    }

    public function getConfig()
    {
        return [
            'payment' => [
                self::CODE => [
                    'form_action' => $this->dataHelper->getFormAction(),
                    'payInStoreCurrency' => $this->dataHelper->getPayInStoreCurrency()
                ]
            ]
        ];
    }
}
