<?php
namespace Risecommerce\Elavon\Observer;

use Magento\Framework\Event\Observer;
use Magento\Payment\Observer\AbstractDataAssignObserver;
use Magento\Quote\Api\Data\PaymentInterface;

/**
 * Class DataAssignObserver
 */
class DataAssignObserver extends AbstractDataAssignObserver
{
    const CC_NUMBER = 'cc_number';
    const CC_CID = 'cc_cid';
    const CC_TYPE = 'cc_type';
    const CC_EXP_MONTH = 'cc_exp_month';
    const CC_EXP_YEAR = 'cc_exp_year';
    const SAVE_CARD = 'is_active_payment_token_enabler';
    const G_CAPTCHA = 'captcha_string';

    /**
     * @var array
     */
    protected $additionalInformationList = [
        self::CC_NUMBER,
        self::CC_CID,
        self::CC_TYPE,
        self::CC_EXP_MONTH,
        self::CC_EXP_YEAR
    ];

    protected $extraData = [
        self::SAVE_CARD,
        self::G_CAPTCHA
    ];

    /**
     * @param Observer $observer
     * @return void
     */
    public function execute(Observer $observer)
    {
        $data = $observer->getData('data');
        $additionalData = $data->getData(PaymentInterface::KEY_ADDITIONAL_DATA);
        $payment = $observer->getData('payment_model');
        foreach ($this->additionalInformationList as $additionalInformationKey) {
            if (isset($additionalData[$additionalInformationKey])) {
                $payment->setData($additionalInformationKey, $additionalData[$additionalInformationKey]);
            }
        }

        foreach ($this->extraData as $extraDataKey) {
            if (isset($additionalData[$extraDataKey])) {
                $payment->setAdditionalInformation(
                    $extraDataKey,
                    $additionalData[$extraDataKey]
                );
            } else {
                $payment->unsAdditionalInformation($extraDataKey);
            }
        }
    }
}
