define([
    'jquery',
    'Magento_Checkout/js/view/payment/default',
    'mage/url',
    'Risecommerce_Elavon/js/action/set-payment-method',
    'Magento_Checkout/js/model/payment/additional-validators',
    'Magento_Customer/js/customer-data'
], function (
     $,
    Component,
    url,
    setPaymentMethodAction,
    additionalValidators,
    customerData
) {
    'use strict';

    return Component.extend({
        defaults: {
            template: "Risecommerce_Elavon/payment/hosted-page"
        },

        getCode: function () {
            return 'risecommerce_elavonhosted_option';
        },

        continueToHostedPage: function () {
            if (additionalValidators.validate()) {
                this.selectPaymentMethod();
                setPaymentMethodAction(this.messageContainer).done(
                    function () {
                        customerData.invalidate(['cart']);
                        $.mage.redirect(url.build('rc_elavon/hosted/start'));
                    }
                );

                return false;
            }
        }
    });
});
